// ConsoleApplication1.cpp : Defines the entry point for the console application.
//

#include "allocator.h"
#include <set>

struct Example
{
  int value;

  Example(int v) :
      value(v)
  {}

  bool operator<(Example const& other) const
  {
      return value < other.value;
  }
};

int main()
{
    std::multiset<Example, std::less<Example>, allocator<Example, heap<Example> > > foo;

    for (int iter = 0; iter < 1000000000; ++iter)
    {
        foo.insert(Example(iter + 3));
        foo.insert(Example(iter + 1));
        foo.insert(Example(iter + 4));
        foo.insert(Example(iter + 2));
    }

    for (std::multiset<Example, std::less<Example>, allocator<Example, heap<Example> > >::const_iterator iter(foo.begin()); iter != foo.end(); ++iter)
    {
        ;
    }

    return 0;
}

